import 'package:redux_enhancement/redux_reducer.dart';
import 'package:redux_enhancement/redux_types.dart';

import '../../model/address.dart';
import 'address_actions.dart';

class AddressReducer<Parent> extends ReduxReducer<Parent, Address> {
  AddressReducer(
    GetterFunction<Parent, Address> getter,
    SetterFunction<Parent, Address> setter,
  ) : super(
          getter: getter,
          setter: setter,
          reducers: {
            getType<ChangeFirstNameAction<Parent>>(): (address, action) => address..firstName = action.value,
            getType<ChangeLastNameAction<Parent>>(): (address, action) => address..lastName = action.value,
          },
        );
}
