import 'package:redux_enhancement/redux_reducer.dart';
import 'package:redux_enhancement/redux_types.dart';

import '../customer/customer_reducer.dart';
import '../shop/shop_reducer.dart';
import 'app_state.dart';
import 'app_state_actions.dart';

class AppStateReducer extends ReduxReducer<AppState, AppState> {
  static Map<Type, ReducerFunction<AppState, dynamic>> _reducers = {
    InitializeAction: (appState, action) => appState..initialized = true,
  };

  AppStateReducer()
      : super(
          getter: (state) => state,
          setter: (state, value) => value,
          reducers: _reducers,
          children: [
            ShopReducer(),
            CustomerReducer(),
          ],
        );
}
