import 'package:redux_enhancement/action_reducer.dart';
import 'package:redux_enhancement/redux_reducer.dart';
import 'package:redux_enhancement/redux_types.dart';

import '../../model/address.dart';
import 'address_actions.dart';

class AddressReducer<Parent> extends ReduxReducer<Parent, Address> {
  AddressReducer(
    GetterFunction<Parent, Address> getter,
    SetterFunction<Parent, Address> setter,
  ) : super(
          getter: getter,
          setter: setter,
          reducers: [
            ActionReducer<Address, ChangeFirstNameAction<Parent>, String>(_firstNameReducer),
            ActionReducer<Address, ChangeLastNameAction<Parent>, String>(_lastNameReducer),
          ],
        );

  static Address _firstNameReducer(Address address, String firstName) => address..firstName = firstName;
  static Address _lastNameReducer(Address address, String lastName) => address..lastName = lastName;
}
